from cpl_query.extension import List

from bot_core.core_extension.core_extension_module import CoreExtensionModule
from bot_core.core_module import CoreModule
from bot_data.data_module import DataModule
from modules.admin.admin_module import AdminModule
from modules.autorole.auto_role_module import AutoRoleModule
from modules.base.base_module import BaseModule
from modules.boot_log.boot_log_module import BootLogModule
from modules.database.database_module import DatabaseModule
from modules.moderator.moderator_module import ModeratorModule
from modules.permission.permission_module import PermissionModule


class ModuleList:

    @staticmethod
    def get_modules():
        # core modules (modules out of modules folder) should be loaded first!
        return List(type, [
            CoreModule,  # has to be first!
            DataModule,
            AdminModule,
            AutoRoleModule,
            BaseModule,
            DatabaseModule,
            ModeratorModule,
            PermissionModule,
            CoreExtensionModule,
            BootLogModule  # has to be last!
        ])
